#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <string.h>

#include "TTree.h"
#include "TFile.h"
#include "TString.h"

#include "TSystem.h"
#include "TH1.h"
#include "TH2.h"
#include "TH3.h"
#include "TCanvas.h"
#include "TStyle.h"
#include "TChain.h"
#include "TEllipse.h"
#include "TLine.h"
#include "TMarker.h"
#include "TVector3.h"
#include "TRotation.h"
#include "TMath.h"
#include "TROOT.h"
#include "TF1.h"
#include "TGraph.h"
#include "TGraphErrors.h"
#include "TLatex.h" 
#include "TPolyLine.h" 


#define DEUTERON_MASS 1.875614
#define PROTON_MASS 0.93827
#define RAD2DEG 57.295779
#define DEG2RAD 0.017453293

using namespace std;

void HallA_style() {

  gROOT->SetStyle("Plain");
  gStyle->SetPaperSize(TStyle::kUSLetter);
  gStyle->SetPaperSize(18,22);
  gStyle->SetOptFit(0);
  gStyle->SetPalette(1);
  gStyle->SetNdivisions(508);
  
  gStyle->SetCanvasColor(10);
  gStyle->SetPadTopMargin(.05);
  gStyle->SetPadLeftMargin(.15);
  gStyle->SetPadRightMargin(.1);
  gStyle->SetPadBottomMargin(.10);
  gStyle->SetTitleYOffset(1.7);
  gStyle->SetTitleXOffset(1.2);
  gStyle->SetLabelFont(42,"X");
  gStyle->SetLabelFont(42,"Y");

  gStyle->SetTitleX(0.2);
  gStyle->SetTitleW(0.7);
  gStyle->SetTitleFillColor(18);

  // prepare gStyle to be useful
  //   1 = solid
  //   2 = long dash (30 10)
  //   3 = dotted (4 8)
  //   4 = dash-dot (15 12 4 12)
  //   5 = short dash ( 15 15 )
  //   6 = dash-dot-dot 
  gStyle->SetLineStyleString(1,"[]");
  gStyle->SetLineStyleString(2,"[30 10]");
  gStyle->SetLineStyleString(3,"[4 8]");
  gStyle->SetLineStyleString(4,"[15 12 4 12]");
  gStyle->SetLineStyleString(5,"[15 15]");
  gStyle->SetLineStyleString(6,"[15 12 4 12 4 12]");
  gStyle->SetLabelSize(0.04,"X");
  gStyle->SetLabelSize(0.04,"Y");
  gStyle->SetNdivisions(508,"Y");
  gStyle->SetOptDate(0);
  gStyle->SetDateY(.98);
  gStyle->SetStripDecimals(kFALSE);


  gStyle->SetOptStat(0);

}


void p0nov(){

  HallA_style();
  TFile *file = new TFile("~/PROJEKT/HIST/1456.root");
  TH1F *h1=(TH1F*)file->Get("h1");
  TH1F *h2=(TH1F*)file->Get("h2");	

  TFile *file2 = new TFile("~/PROJEKT/HIST/1461.root");
  TH1F *h3=(TH1F*)file2->Get("h1");
  TH1F *h4=(TH1F*)file2->Get("h2");	
  //########################--- Canvas C0 1456##################
//##############################################################
//#############################################################
 TCanvas *c0 = new TCanvas("c0","Energije sipanih elektronov 1456",1000,1000);

  c0->Divide(2,2);
  c0->cd(1);
  h1->Draw();
  h1->GetXaxis()->SetTitle("p [GeV/c]");
  h1->SetTitle("P");


//##########fitting
 

  TF1 *g1    = new TF1("g1","gaus",1.2288,1.23);
  h1->Fit(g1,"R");
  
  TF1 *g2    = new TF1("g2","gaus",1.2340,1.2350);
  h1->Fit(g2,"R+");




//########################...TLine
  //TLine *b1 = new TLine(1.23898, 0 ,1.23898, 850);
  //b1->SetLineColor(kRed);
  //b1->SetLineWidth(2);
  //b1->Draw();
  TLine *b2 = new TLine(1.2345411, 0 ,1.2345411, 850);
  b2->SetLineColor(kRed);
  b2->SetLineWidth(2);
  b2->Draw("");
  //TLine *b3 = new TLine(1.2313258, 0 ,1.2313258, 850);
  //b3->SetLineColor(kRed);
  //b3->Draw("same");
  TLine *b4 = new TLine(1.229339, 0 ,1.229339, 850);
  b4->SetLineColor(kRed);
  b4->SetLineWidth(2);
  b4->Draw("same");
  //TLine *b5 = new TLine(1.228136, 0 ,1.228136, 850);
  //b5->SetLineColor(kRed);
  //b5->Draw("same");
  //TLine *b6 = new TLine(1.22627, 0 ,1.22627, 850);
  //b6->SetLineColor(kRed);
  //b6->Draw("same");
  //TLine *b7 = new TLine(1.224897, 0 ,1.224897, 850);
  //b7->SetLineColor(kRed);
  //b7->Draw("same");
  //TLine *b8 = new TLine(1.22354, 0 ,1.22354, 850);
  //b8->SetLineColor(kRed);
  //b8->Draw("same");
  //TLine *b9 = new TLine(1.22175, 0 ,1.22175, 850);
  //b9->SetLineColor(kRed);
  //b9->Draw("same");

//dp

 c0->cd(2);
 h2->Draw();
 h2->GetXaxis()->SetTitle("p [GeV/c]");
 h2->SetTitle("DP");

//##########fitting
  

  TF1 *g3    = new TF1("g3","gaus",-0.0075,-0.0065);
  h2->Fit(g3,"R");
  TF1 *g4    = new TF1("g4","gaus",-0.0033,-0.0026);
  h2->Fit(g4,"R+");
//###########################NAREDI PREMICO IZ PARAMETROU
	double chisq1=g1->GetChisquare();
	double ndf1=g1->GetNDF();
	double chisqdf1=chisq1/ndf1;
	cout << "Chisquare: " << chisq1 << "/" << ndf1 << " : " << chisqdf1 << endl;
	double chisq2=g2->GetChisquare();
	double ndf2=g2->GetNDF();
	double chisqdf2=chisq2/ndf2;
	cout << "Chisquare: " << chisq2 << "/" << ndf2 << " : " << chisqdf2 << endl;
	double chisq3=g3->GetChisquare();
	double ndf3=g3->GetNDF();
	double chisqdf3=chisq3/ndf3;
	cout << "Chisquare: " << chisq3 << "/" << ndf3 << " : " << chisqdf3 << endl;
	double chisq4=g4->GetChisquare();
	double ndf4=g4->GetNDF();
	double chisqdf4=chisq4/ndf4;
	cout << "Chisquare: " << chisq4 << "/" << ndf4 << " : " << chisqdf4 << endl;

 c0->cd(3);

   
  	Double_t mean1 = g1->GetParameter(1); 
	Double_t emean1 = g1->GetParError(1); 
	Double_t mean2 = g2->GetParameter(1); 
	Double_t emean2 = g2->GetParError(1); 

	Double_t mean3 = g3->GetParameter(1); 
	Double_t emean3 = g3->GetParError(1); 
	Double_t mean4 = g4->GetParameter(1); 
	Double_t emean4 = g4->GetParError(1); 

	 // Double_t mean1=1, mean2=2, mean3=3, mean4=4, emean1=1, emean2=2, emean3=3, emean4=4 ;
  	Double_t y[2] = {mean1, mean2};
  	Double_t x[2] = {mean3, mean4};
  	Double_t ey[2] = {emean1, emean2};
  	Double_t ex[2] = {emean3, emean4};

 	TGraphErrors *graf= new TGraphErrors(2,x,y,ex,ey);
  	graf->SetMarkerStyle(20);
  	graf->SetMarkerColor(kRed);
  graf->Draw("AP");
//#############FIT P0
   TF1 *p0fit = new TF1("p0fit","[0]*x+[1]", -0.008, -0.002);
   p0fit->SetParLimits(1,1., 2.0);
   p0fit->SetParLimits(0,0.7, 2.3);
   graf->Fit(p0fit,"RW");
  
	double chisq=p0fit->GetChisquare();
	double ndf=p0fit->GetNDF();
	double chisqdf=chisq/ndf;
	cout << "Chisquare: " << chisq << "/" << ndf << " : " << chisqdf << endl;
	

//##############text
	Double_t meanp0 = p0fit->GetParameter(0);
	Double_t emeanp0 = p0fit->GetParError(0);
	c0->cd(4);
	TString beseda = Form("p_{0}= %.5f #pm %.5f #frac{MeV}{c}",meanp0, emeanp0);

	TLatex ltext;
	ltext.SetTextSize(0.1);
	ltext.DrawLatex(0.1, 0.2, beseda.Data());



  //########################--- Canvas C0 1461##################
//##############################################################
//#############################################################
 TCanvas *c1 = new TCanvas("c1","Energije sipanih elektronov 1461",1000,1000);

 c1->Divide(2,2);
c1->cd(1);
 h3->Draw();
  h3->GetXaxis()->SetTitle("p [GeV/c]");
  h3->SetTitle("P");


//##########fitting
 

  TF1 *g5    = new TF1("g5","gaus",1.2288,1.2299);
  h1->Fit(g5,"R");
  
  TF1 *g6    = new TF1("g6","gaus",1.2339,1.2351);
  h1->Fit(g6,"R+");




//########################...TLine
  //TLine *b1 = new TLine(1.23898, 0 ,1.23898, 850);
  //b1->SetLineColor(kRed);
  //b1->SetLineWidth(2);
  //b1->Draw();
  TLine *b22 = new TLine(1.2345411, 0 ,1.2345411, 850);
  b22->SetLineColor(kRed);
  b22->SetLineWidth(2);
 b22->Draw("");
  //TLine *b3 = new TLine(1.2313258, 0 ,1.2313258, 850);
  //b3->SetLineColor(kRed);
  //b3->Draw("same");
  TLine *b24 = new TLine(1.229339, 0 ,1.229339, 850);
  b24->SetLineColor(kRed);
  b24->SetLineWidth(2);
 b24->Draw("same");
  //TLine *b5 = new TLine(1.228136, 0 ,1.228136, 850);
  //b5->SetLineColor(kRed);
  //b5->Draw("same");
  //TLine *b6 = new TLine(1.22627, 0 ,1.22627, 850);
  //b6->SetLineColor(kRed);
  //b6->Draw("same");
  //TLine *b7 = new TLine(1.224897, 0 ,1.224897, 850);
  //b7->SetLineColor(kRed);
  //b7->Draw("same");
  //TLine *b8 = new TLine(1.22354, 0 ,1.22354, 850);
  //b8->SetLineColor(kRed);
  //b8->Draw("same");
  //TLine *b9 = new TLine(1.22175, 0 ,1.22175, 850);
  //b9->SetLineColor(kRed);
  //b9->Draw("same");

//dp

  c1->cd(2);
 h4->Draw();
  h4->GetXaxis()->SetTitle("p [GeV/c]");
 h4->SetTitle("DP");

//##########fitting
  

  TF1 *g7    = new TF1("g7","gaus",0.0238,0.0247);
  h4->Fit(g7,"R");
  TF1 *g8    = new TF1("g8","gaus",0.0280,0.0295);
  h4->Fit(g8,"R+");
//###########################NAREDI PREMICO IZ PARAMETROU
	double chisq5=g5->GetChisquare();
	double ndf5=g5->GetNDF();
	double chisqdf5=chisq5/ndf5;
	cout << "Chisquare: " << chisq5 << "/" << ndf5 << " : " << chisqdf5 << endl;
	double chisq6=g6->GetChisquare();
	double ndf6=g6->GetNDF();
	double chisqdf6=chisq6/ndf6;
	cout << "Chisquare: " << chisq6 << "/" << ndf6 << " : " << chisqdf6 << endl;
	double chisq7=g7->GetChisquare();
	double ndf7=g7->GetNDF();
	double chisqdf7=chisq7/ndf7;
	cout << "Chisquare: " << chisq7 << "/" << ndf7 << " : " << chisqdf7 << endl;
	double chisq8=g8->GetChisquare();
	double ndf8=g8->GetNDF();
	double chisqdf8=chisq4/ndf8;
	cout << "Chisquare: " << chisq8 << "/" << ndf8 << " : " << chisqdf8 << endl;

 c1->cd(3);

   
  	Double_t mean21 = g5->GetParameter(1); 
	Double_t emean21 = g5->GetParError(1); 
	Double_t mean22 = g6->GetParameter(1); 
	Double_t emean22 = g6->GetParError(1); 

	Double_t mean23 = g7->GetParameter(1); 
	Double_t emean23 = g7->GetParError(1); 
	Double_t mean24 = g8->GetParameter(1); 
	Double_t emean24 = g8->GetParError(1); 

	 // Double_t mean1=1, mean2=2, mean3=3, mean4=4, emean1=1, emean2=2, emean3=3, emean4=4 ;
  	Double_t y2[2] = {mean21, mean22};
  	Double_t x2[2] = {mean23, mean24};
  	Double_t ey2[2] = {emean21, emean22};
  	Double_t ex2[2] = {emean23, emean24};

 	TGraphErrors *graf2= new TGraphErrors(2,x2,y2,ex2,ey2);
  	graf2->SetMarkerStyle(20);
  	graf2->SetMarkerColor(kRed);
  graf2->Draw("AP");
//#############FIT P0
   TF1 *p0fit2 = new TF1("p0fit2","[0]*x+[1]", mean23, mean24);
   graf2->Fit(p0fit2,"R+");
	double chisq22=p0fit2->GetChisquare();
	double ndf22=p0fit2->GetNDF();
	double chisqdf22=chisq22/ndf22;
	cout << "Chisquare:" << chisq22 << "/" << ndf22 << " : " << chisqdf22 << endl;
	

//##############text
	Double_t meanp02 = p0fit2->GetParameter(0);
	Double_t emeanp02 = p0fit2->GetParError(0);
	c1->cd(4);
	TString beseda2 = Form("p_{0}= %.5f #pm %.5f #frac{MeV}{c}",meanp02, emeanp02);

	TLatex ltext2;
	ltext2.SetTextSize(0.1);
	ltext2.DrawLatex(0.1, 0.2, beseda2.Data());


	
}





