#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <string.h>

#include "TTree.h"
#include "TFile.h"
#include "TString.h"

#include "TSystem.h"
#include "TH1.h"
#include "TH2.h"
#include "TH3.h"
#include "TCanvas.h"
#include "TStyle.h"
#include "TChain.h"
#include "TEllipse.h"
#include "TLine.h"
#include "TMarker.h"
#include "TVector3.h"
#include "TRotation.h"
#include "TMath.h"
#include "TROOT.h"
#include "TF1.h"
#include "TGraph.h"
#include "TGraphErrors.h"
#include "TLatex.h" 
#include "TPolyLine.h" 


#define DEUTERON_MASS 1.875614
#define PROTON_MASS 0.93827
#define RAD2DEG 57.295779
#define DEG2RAD 0.017453293

using namespace std;

void HallA_style() {

  gROOT->SetStyle("Plain");
  gStyle->SetPaperSize(TStyle::kUSLetter);
  gStyle->SetPaperSize(18,22);
  gStyle->SetOptFit(0);
  gStyle->SetPalette(1);
  gStyle->SetNdivisions(508);
  
  gStyle->SetCanvasColor(10);
  gStyle->SetPadTopMargin(.05);
  gStyle->SetPadLeftMargin(.15);
  gStyle->SetPadRightMargin(.1);
  gStyle->SetPadBottomMargin(.10);
  gStyle->SetTitleYOffset(1.7);
  gStyle->SetTitleXOffset(1.2);
  gStyle->SetLabelFont(42,"X");
  gStyle->SetLabelFont(42,"Y");

  gStyle->SetTitleX(0.2);
  gStyle->SetTitleW(0.7);
  gStyle->SetTitleFillColor(18);

  // prepare gStyle to be useful
  //   1 = solid
  //   2 = long dash (30 10)
  //   3 = dotted (4 8)
  //   4 = dash-dot (15 12 4 12)
  //   5 = short dash ( 15 15 )
  //   6 = dash-dot-dot 
  gStyle->SetLineStyleString(1,"[]");
  gStyle->SetLineStyleString(2,"[30 10]");
  gStyle->SetLineStyleString(3,"[4 8]");
  gStyle->SetLineStyleString(4,"[15 12 4 12]");
  gStyle->SetLineStyleString(5,"[15 15]");
  gStyle->SetLineStyleString(6,"[15 12 4 12 4 12]");
  gStyle->SetLabelSize(0.04,"X");
  gStyle->SetLabelSize(0.04,"Y");
  gStyle->SetNdivisions(508,"Y");
  gStyle->SetOptDate(0);
  gStyle->SetDateY(.98);
  gStyle->SetStripDecimals(kFALSE);


  gStyle->SetOptStat(0);

}

using namespace std;

int p0v51(){

  HallA_style();

  TString produceroot, Y="Y", N="N";


  cout<<"################### ROOT File to Histogram ROOT File #######################"<<endl;
  while(produceroot.CompareTo(Y)!=0 && produceroot.CompareTo(N)!=0){


	cout<<"A SPRODUCIRAM HISTOGRAME V ROOT: (Y/N)"<<endl;
        cin>>produceroot;

	if(produceroot.CompareTo(N)==0) break;
	if(produceroot.CompareTo(Y)==0){


		Double_t L_gold_p;
		Double_t L_gold_dp;
		Double_t  grafP[2], grafdP[2];
		Int_t runnumber;
		cout<<"Vpisi Run Number:"<<endl;
 		cin>>runnumber;
  		cout<<"Run Number je: "<<runnumber<<endl;


  		cout<<"Vpisi meje za P histogram:"<<endl<<"Prva meja:"<<endl;
  		cin>>grafP[0];
  		cout<<"Prva meja je: "<<grafP[0]<<endl<<"Druga meja;"<<endl;
  		cin>>grafP[1];
  		cout<<"Druga meja meja je: "<<grafP[1]<<endl;

  		cout<<"Vpisi meje za dP histogram:"<<endl<<"Prva meja:"<<endl;
  		cin>>grafdP[0];
  		cout<<"Prva meja je: "<<grafdP[0]<<endl<<"Druga meja;"<<endl;
  		cin>>grafdP[1];
  		cout<<"Druga meja meja je: "<<grafdP[1]<<endl;


  		TChain *t1 =new TChain("T");

  		TString filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber, runnumber);
  		t1->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber, runnumber);
  		t1->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+1, runnumber+1);
  		t1->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+1, runnumber+1);
  		t1->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+2, runnumber+2);
  		t1->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+2, runnumber+2);
  		t1->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+3, runnumber+3);
  		t1->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+3, runnumber+3);
  		t1->Add(filename.Data());


  		assert(t1);


  		TChain *t2 =new TChain("T");

  		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber, runnumber);
  		t2->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber, runnumber);
  		t2->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+1, runnumber+1);
  		t2->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+1, runnumber+1);
  		t2->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+2, runnumber+2);
  		t2->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+2, runnumber+2);
  		t2->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+3, runnumber+3);
  		t2->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+3, runnumber+3);
  		t2->Add(filename.Data());

  		assert(t2);
  
	//############################ VARIABLES ############################

  		t1->SetBranchAddress( "L.gold.p", &L_gold_p);
  		t2->SetBranchAddress( "L.gold.dp", &L_gold_dp);
	//############################ Histograms ############################


  		TH1F *h1 = new TH1F("h1","h1",200,grafP[0],grafP[1]);
  		TH1F *h2 = new TH1F("h2","h2",200,grafdP[0],grafdP[1]);
 

	//############################ Analysis p ############################

  		int num = t1->GetEntries();
  		//num = 30000;
  		cout<<"Number of entries : "<<num<<endl;

 		for (int i = 0; i<num; i++)
  		{
   		t1->GetEntry(i);
    		if ((i%1000==0) && i>0) cout<<i<<endl; 

	//################ Primary Cuts ################################


                                                  
	//##############################################################  

   		h1->Fill(L_gold_p);  

  		}

  		delete t1; t1=NULL;

	
	//############################ Analysis dp ############################

 		num = t2->GetEntries();
  		//num = 30000;
  		cout<<"Number of entries : "<<num<<endl;

  		for (int i = 0; i<num; i++)
  		{
    		t2->GetEntry(i);
    		if ((i%1000==0) && i>0) cout<<i<<endl; 

	//################ Primary Cuts ################################


                                                  
	//##############################################################  

   		h2->Fill(L_gold_dp);  

 		}


  		delete t2; t2=NULL;


	//########################### OUTPUTFILE###############


		TString filename3=Form("~/PROJEKT/P0/HIST/%dindalje.root",runnumber);
		TFile *OutputRoot = new TFile( filename3.Data(), "RECREATE");
		h1->Write();
		h2->Write();
		delete OutputRoot; OutputRoot=NULL;
		
		produceroot=3;
		TString narisemhisto=3;
		cout<<"A narisem: (Y/N)"<<endl;
        	cin>>narisemhisto;
		if(narisemhisto.CompareTo(Y)==0) {

			TString canvasname=Form("Energije sipanih elektronov %d CELI HISTOGRAMI", runnumber);
		        TCanvas *c0 = new TCanvas(canvasname,canvasname,1000,1000);

 			c0->Divide(2,1);
 			c0->cd(1);
 			h1->Draw();
 			h1->GetXaxis()->SetTitle("p [GeV/c]");
 			h1->SetTitle("P");
 			c0->cd(2);
 			h2->Draw();
 			h2->GetXaxis()->SetTitle("%");
 			h2->SetTitle("dP");			
		}
	}
  }

//################################ RISANJE CELIH HISTOGRAMOV

	cout<<"###############  RISANJE CELIH HISTOGRAMOV  #################"<<endl;

	Int_t runnumber=3;
	HallA_style();

	while(runnumber!=0){      
		cout<<"Vpisi Run Number ali konec: (runnumber/0)"<<endl;
        	cin>>runnumber;
		if(runnumber==0) break;
		TString celihistogrami=Form("~/PROJEKT/P0/HIST/%dindalje.root", runnumber);
  		TFile *file = new TFile(celihistogrami.Data());
  		TH1F *h10=(TH1F*)file->Get("h1");
  		TH1F *h20=(TH1F*)file->Get("h2");	

	
		TString canvasname=Form("Energije sipanih elektronov %d CELI HISTOGRAMI", runnumber);
		TCanvas *c10 = new TCanvas(canvasname,canvasname,1000,500);

 		c10->Divide(2,1);
 		c10->cd(1);
 		h10->Draw();
 		h10->GetXaxis()->SetTitle("p [GeV/c]");
 		h10->SetTitle("P");
 		c10->cd(2);
 		h20->Draw();
 		h20->GetXaxis()->SetTitle("%");
 		h20->SetTitle("dP");	
		}



//################################     IZ ROOT HISTOGRAMOV DO P0       ###########################
	runnumber=3; //narisem;
  	Double_t fitprvigraf[6];
  	Double_t fitdrugigraf[6]; 
  	Double_t p0rezultat;
	Double_t ep0;
	TString narisem;
 	
	cout<<"###############  IZ ROOT HISTOGRAMOV DO p0  #################"<<endl;
	while(runnumber!=0)
		{
        	cout<<"Vpisi Run Number ali konec: (runnumber/0)"<<endl;
        	cin>>runnumber;
		cout<<"Run Number je: "<<runnumber<<endl;
		if(runnumber==0) break;
		narisem=3;
		while(narisem.CompareTo(Y)!=0 && narisem.CompareTo(N)!=0){
			cout<<"A narisem: (Y/N)"<<endl;
        		cin>>narisem;
		}
		if(narisem.CompareTo(Y)==0){

	//#######################    BRANJE IZ DATOTEKE data ##############################
			TString filenamedata=Form("PROJEKT/P0/DATA/%ddata.txt", runnumber);
			ifstream data;
        		data.open (filenamedata.Data());

			int counter=0;
			if (data.is_open())
  			{
    			  	while ( ! data.eof() ){
    		  			double berime;
	 	   			data>>berime;
         	   			cout<<berime<<endl;
         	   			if (counter<6){
         	     				fitprvigraf[counter]=berime;
          	  			}
          	  			else{
           	   				fitdrugigraf[counter-6]=berime;
           	 			}
          	  			counter++;
					}
        			data.close();
  			}
  			else cout << "Unable to open file/n"; 

	//######################   BRANJE HISTOGRAMOV IZ DATOTEKE root   ############################
		  			HallA_style();
  			TString filename=Form("~/PROJEKT/P0/HIST/%dindalje.root", runnumber);
  			TFile *file = new TFile(filename.Data());
  			TH1F *h1=(TH1F*)file->Get("h1");
  			TH1F *h2=(TH1F*)file->Get("h2");	



	//###########################   RISANJE Canvas C0   ##################################
			TString canvasname=Form("Energije sipanih elektronov %d", runnumber);
		        TCanvas *c0 = new TCanvas(canvasname,canvasname,1000,1000);

 			c0->Divide(2,2);
 			c0->cd(1);
			TString imeh=Form("P %d in dalje", runnumber);
 			h1->Draw();
 			h1->GetXaxis()->SetTitle("p [GeV/c]");
 			h1->SetTitle(imeh);

			

	//###################### RISANJE    fitting prvi graf        ##################
		
  			TF1 *g1    = new TF1("g1","gaus", fitprvigraf[0], fitprvigraf[1]);
  			h1->Fit(g1,"R");
  
  			TF1 *g2    = new TF1("g2","gaus",fitprvigraf[2],fitprvigraf[3]);
  			h1->Fit(g2,"R+");
			
  			TF1 *g5    = new TF1("g5","gaus",fitprvigraf[4],fitprvigraf[5]);
  			h1->Fit(g5,"R+");
	//######################## RISANJE      TLine            #######################



  			TLine *b2 = new TLine(1.2345411, 0 ,1.2345411, 850);
  			b2->SetLineColor(kRed);
  			b2->SetLineWidth(2);
 			b2->Draw("");
		
   			TLine *b4 = new TLine(1.229339, 0 ,1.229339, 850);
  			b4->SetLineColor(kRed);
  			b4->SetLineWidth(2);
			b4->Draw("same");
	
  			
	//#####################  RISANJE      dp                 #########################
	
  			c0->cd(2);
 			h2->Draw();
			TString imeh2=Form("dP %d in dalje", runnumber);
 			h2->GetXaxis()->SetTitle("p [GeV/c]");
 			h2->SetTitle(imeh2);
			
	//#####################    RISANJE           fitting dp
  

  			TF1 *g3    = new TF1("g3","gaus",fitdrugigraf[0], fitdrugigraf[1]);
  			h2->Fit(g3,"R");
  			TF1 *g4    = new TF1("g4","gaus",fitdrugigraf[2], fitdrugigraf[3]);
  			h2->Fit(g4,"R+");
  			TF1 *g6   = new TF1("g6","gaus",0.0317, 0.0332);
  			h2->Fit(g6,"R+");
			
	//##################### RISANJE  NAREDI PREMICO ZA P0 IZ PARAMETROU ###############



			double chisq1=g1->GetChisquare();
			double ndf1=g1->GetNDF();
			double chisqdf1=chisq1/ndf1;
			cout << "Chisquare: " << chisq1 << "/" << ndf1 << " : " << chisqdf1 << endl;
			double chisq2=g2->GetChisquare();
			double ndf2=g2->GetNDF();
			double chisqdf2=chisq2/ndf2;
			cout << "Chisquare: " << chisq2 << "/" << ndf2 << " : " << chisqdf2 << endl;
			double chisq3=g3->GetChisquare();
			double ndf3=g3->GetNDF();
			double chisqdf3=chisq3/ndf3;
			cout << "Chisquare: " << chisq3 << "/" << ndf3 << " : " << chisqdf3 << endl;
			double chisq4=g4->GetChisquare();
			double ndf4=g4->GetNDF();
			double chisqdf4=chisq4/ndf4;
			cout << "Chisquare: " << chisq4 << "/" << ndf4 << " : " << chisqdf4 << endl;
			double chisq5=g5->GetChisquare();
			double ndf5=g5->GetNDF();
			double chisqdf5=chisq5/ndf5;
			cout << "Chisquare: " << chisq5 << "/" << ndf5 << " : " << chisqdf5 << endl;
			double chisq6=g6->GetChisquare();
			double ndf6=g6->GetNDF();
			double chisqdf6=chisq6/ndf6;
			cout << "Chisquare: " << chisq6 << "/" << ndf6 << " : " << chisqdf6 << endl;


			c0->cd(3);


   
  			Double_t mean1 = g1->GetParameter(1); 
			Double_t emean1 = g1->GetParError(1); 
			Double_t mean2 = g2->GetParameter(1); 
			Double_t emean2 = g2->GetParError(1); 
			Double_t mean5 = g5->GetParameter(1); 
			Double_t emean5 = g5->GetParError(1); 

			Double_t mean3 = g3->GetParameter(1); 
			Double_t emean3 = g3->GetParError(1); 
			Double_t mean4 = g4->GetParameter(1); 
			Double_t emean4 = g4->GetParError(1); 
			Double_t mean6 = g6->GetParameter(1); 
			Double_t emean6 = g6->GetParError(1); 


			Double_t y[3] = {mean1, mean2, mean5};
  			Double_t x[3] = {mean3, mean4, mean6};
  			Double_t ey[3] = {emean1, emean2, emean5};
  			Double_t ex[3] = {emean3, emean4, emean6};

 			TGraphErrors *graf= new TGraphErrors(3,x,y,ex,ey);
  			graf->SetMarkerStyle(20);
  			graf->SetMarkerColor(kRed);
 	
			graf->Draw("AP");
		

		//#############    FIT P0 risanje   #######################



   			TF1 *p0fit = new TF1("p0fit","[0]*x+[1]", mean3, mean6);
   			p0fit->SetParLimits(1,1., 2.0);
   			p0fit->SetParLimits(0,0.7, 2.3);
   			graf->Fit(p0fit,"RW");
  
			double chisq=p0fit->GetChisquare();
			double ndf=p0fit->GetNDF();
			double chisqdf=chisq/ndf;
			cout << "Chisquare: " << chisq << "/" << ndf << " : " << chisqdf << endl;
	

		//##############text risanje  ############################
			Double_t meanp0 = p0fit->GetParameter(0);
			Double_t emeanp0 = p0fit->GetParError(0);
	
			c0->cd(4);
		
			TString beseda = Form("p_{0}= %.5f #pm %.5f #frac{MeV}{c}", meanp0, emeanp0);
			TString beseda2 = Form("Zdruzeni podatki: %d, %d, %d, %d", runnumber, runnumber+1, runnumber+2, runnumber+3);
			TLatex ltext;
			ltext.SetTextSize(0.05);
			ltext.DrawLatex(0.1, 0.3, beseda.Data());		
			TLatex ltext1;
			ltext1.SetTextSize(0.05);
			ltext1.DrawLatex(0.1, 0.6, beseda2.Data());
			
		//##############shranjevanje p0 risanje #####################
			p0rezultat=meanp0;
			ep0=emeanp0;



		//###########napiss v file risanje #########################
			TString saveresults="3";
			cout<<"A SHRANIM REZULTATE?: (Y/N)"<<endl;
       			cin>>saveresults;

			if(saveresults.CompareTo(Y)==0){


				TString filename2=Form("Run Number: %d", runnumber);
				fstream myfile;
				myfile.open("PROJEKT/P0/rezultativ2skupni.txt", 	fstream::in | fstream::out | fstream::app);
				myfile<<filename2<<"   p0 = "<<p0rezultat<<" +-  "<<ep0<<endl;
	
				myfile.close();
			}
			narisem=3;
								
		}
		else{

	//#######################    BRANJE IZ DATOTEKE data ##############################
			TString filenamedata=Form("PROJEKT/P0/DATA/%ddata.txt", runnumber);
			ifstream data;
        		data.open (filenamedata.Data());

			int counter=0;
			if (data.is_open())
  			{
    			  	while ( ! data.eof() ){
    		  			double berime;
	 	   			data>>berime;
         	   			cout<<berime<<endl;
         	   			if (counter<4){
         	     				fitprvigraf[counter]=berime;
          	  			}
          	  			else{
           	   				fitdrugigraf[counter-4]=berime;
           	 			}
          	  			counter++;
					}
        			data.close();
  			}
  			else cout << "Unable to open file/n"; 

	//######################   BRANJE HISTOGRAMOV IZ DATOTEKE root   ############################
  
  			HallA_style();
  			TString filename=Form("~/PROJEKT/P0/HIST/%dindalje.root", runnumber);
  			TFile *file = new TFile(filename.Data());
  			TH1F *h1=(TH1F*)file->Get("h1");
  			TH1F *h2=(TH1F*)file->Get("h2");	



		//######################        fitting prvi graf      ##################
 
		
  			TF1 *g1    = new TF1("g1","gaus", fitprvigraf[0], fitprvigraf[1]);
  			h1->Fit(g1,"RN");
  
  			TF1 *g2    = new TF1("g2","gaus",fitprvigraf[2],fitprvigraf[3]);
  			h1->Fit(g2,"RN+");
			
		//########################    ...TLine                  #######################



    			TLine *b2 = new TLine(1.2345411, 0 ,1.2345411, 850);
  			b2->SetLineColor(kRed);
  			b2->SetLineWidth(2);
   			TLine *b4 = new TLine(1.229339, 0 ,1.229339, 850);
  			b4->SetLineColor(kRed);
  			b4->SetLineWidth(2);
		

		//######################        fitting
  

  			TF1 *g3    = new TF1("g3","gaus",fitdrugigraf[0], fitdrugigraf[1]);
  			h2->Fit(g3,"RN");
  			TF1 *g4    = new TF1("g4","gaus",fitdrugigraf[2], fitdrugigraf[3]);
  			h2->Fit(g4,"RN+");
			
		//###########################    NAREDI PREMICO IZ PARAMETROU  ################



			double chisq1=g1->GetChisquare();
			double ndf1=g1->GetNDF();
			double chisqdf1=chisq1/ndf1;
			cout << "Chisquare: " << chisq1 << "/" << ndf1 << " : " << chisqdf1 << endl;
			double chisq2=g2->GetChisquare();
			double ndf2=g2->GetNDF();
			double chisqdf2=chisq2/ndf2;
			cout << "Chisquare: " << chisq2 << "/" << ndf2 << " : " << chisqdf2 << endl;
			double chisq3=g3->GetChisquare();
			double ndf3=g3->GetNDF();
			double chisqdf3=chisq3/ndf3;
			cout << "Chisquare: " << chisq3 << "/" << ndf3 << " : " << chisqdf3 << endl;
			double chisq4=g4->GetChisquare();
			double ndf4=g4->GetNDF();
			double chisqdf4=chisq4/ndf4;
			cout << "Chisquare: " << chisq4 << "/" << ndf4 << " : " << chisqdf4 << endl;

	   
  			Double_t mean1 = g1->GetParameter(1); 
			Double_t emean1 = g1->GetParError(1); 
			Double_t mean2 = g2->GetParameter(1); 
			Double_t emean2 = g2->GetParError(1); 

			Double_t mean3 = g3->GetParameter(1); 
			Double_t emean3 = g3->GetParError(1); 
			Double_t mean4 = g4->GetParameter(1); 
			Double_t emean4 = g4->GetParError(1); 

	
  			Double_t y[2] = {mean1, mean2};
  			Double_t x[2] = {mean3, mean4};
  			Double_t ey[2] = {emean1, emean2};
  			Double_t ex[2] = {emean3, emean4};

 			TGraphErrors *graf= new TGraphErrors(2,x,y,ex,ey);
  			graf->SetMarkerStyle(20);
  			graf->SetMarkerColor(kRed);
 	
		
		//#############            FIT P0          ###################



   			TF1 *p0fit = new TF1("p0fit","[0]*x+[1]", mean3, mean4);
   			p0fit->SetParLimits(1,1., 2.0);
   			p0fit->SetParLimits(0,0.7, 2.3);
   			graf->Fit(p0fit,"RW");
  
			double chisq=p0fit->GetChisquare();
			double ndf=p0fit->GetNDF();
			double chisqdf=chisq/ndf;
			cout << "Chisquare: " << chisq << "/" << ndf << " : " << chisqdf << endl;
	

		//##############          text   ###########################

			Double_t meanp0 = p0fit->GetParameter(0);
			Double_t emeanp0 = p0fit->GetParError(0);
	
			
			TString beseda = Form("p_{0}= %.5f #pm %.5f #frac{MeV}{c}",meanp0, emeanp0);

			TLatex ltext;
			ltext.SetTextSize(0.1);
		
			
		//##############     shranjevanje p0    #####################
			p0rezultat=meanp0;
			ep0=emeanp0;



		//###########         napiss v file       ####################
			TString saveresults="3";
			cout<<"A SHRANIM REZULTATE?: (Y/N)"<<endl;
       			cin>>saveresults;

			if(saveresults.CompareTo(Y)==0){


			TString filename2=Form("Run Number: %d", runnumber);
			fstream myfile;
			myfile.open("PROJEKT/P0/rezultativ2skupni.txt", 	fstream::in | fstream::out | fstream::app);
			myfile<<filename2<<"   p0 = "<<p0rezultat<<" +-  "<<ep0<<endl;
	
			myfile.close();
			}

		}

	}
	cout<<"KONEC LONEC"<<endl;
return 0;	
}





