#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <string.h>

#include "TTree.h"
#include "TFile.h"
#include "TString.h"

#include "TSystem.h"
#include "TH1.h"
#include "TH2.h"
#include "TH3.h"
#include "TCanvas.h"
#include "TStyle.h"
#include "TChain.h"
#include "TEllipse.h"
#include "TLine.h"
#include "TMarker.h"
#include "TVector3.h"
#include "TRotation.h"
#include "TMath.h"
#include "TROOT.h"
#include "TF1.h"
#include "TGraph.h"
#include "TGraphErrors.h"
#include "TLatex.h" 
#include "TPolyLine.h" 


#define DEUTERON_MASS 1.875614
#define PROTON_MASS 0.93827
#define RAD2DEG 57.295779
#define DEG2RAD 0.017453293

using namespace std;

void HallA_style() {

  gROOT->SetStyle("Plain");
  gStyle->SetPaperSize(TStyle::kUSLetter);
  gStyle->SetPaperSize(18,22);
  gStyle->SetOptFit(0);
  gStyle->SetPalette(1);
  gStyle->SetNdivisions(508);
  
  gStyle->SetCanvasColor(10);
  gStyle->SetPadTopMargin(.05);
  gStyle->SetPadLeftMargin(.15);
  gStyle->SetPadRightMargin(.1);
  gStyle->SetPadBottomMargin(.10);
  gStyle->SetTitleYOffset(1.7);
  gStyle->SetTitleXOffset(1.2);
  gStyle->SetLabelFont(42,"X");
  gStyle->SetLabelFont(42,"Y");

  gStyle->SetTitleX(0.2);
  gStyle->SetTitleW(0.7);
  gStyle->SetTitleFillColor(18);

  // prepare gStyle to be useful
  //   1 = solid
  //   2 = long dash (30 10)
  //   3 = dotted (4 8)
  //   4 = dash-dot (15 12 4 12)
  //   5 = short dash ( 15 15 )
  //   6 = dash-dot-dot 
  gStyle->SetLineStyleString(1,"[]");
  gStyle->SetLineStyleString(2,"[30 10]");
  gStyle->SetLineStyleString(3,"[4 8]");
  gStyle->SetLineStyleString(4,"[15 12 4 12]");
  gStyle->SetLineStyleString(5,"[15 15]");
  gStyle->SetLineStyleString(6,"[15 12 4 12 4 12]");
  gStyle->SetLabelSize(0.04,"X");
  gStyle->SetLabelSize(0.04,"Y");
  gStyle->SetNdivisions(508,"Y");
  gStyle->SetOptDate(0);
  gStyle->SetDateY(.98);
  gStyle->SetStripDecimals(kFALSE);


  gStyle->SetOptStat(0);

}

using namespace std;

int risanjehistogramov(){	

Int_t runnumber=3;
	HallA_style();

	while(runnumber!=0){      
		cout<<"Vpisi Run Number ali konec: (runnumber/0)"<<endl;
        	cin>>runnumber;
		if(runnumber==0) break;
		TString celihistogrami=Form("~/PROJEKT/P0/HIST/%d.root", runnumber);
  		TFile *file = new TFile(celihistogrami.Data());
  		TH1F *h10=(TH1F*)file->Get("h1");
  		TH1F *h20=(TH1F*)file->Get("h2");	

	
		TString canvasname=Form("Energije sipanih elektronov %d CELI HISTOGRAMI", runnumber);
		TCanvas *c10 = new TCanvas(canvasname,canvasname,1000,500);

 		c10->Divide(2,1);
 		c10->cd(1);
 		h10->Draw();
 		h10->GetXaxis()->SetTitle("p [GeV/c]");
 		h10->SetTitle("P");

		TLine *b10 = new TLine(1.23898, 0 ,1.23898, 850);
  		b10->SetLineColor(kRed);
  		b10->SetLineWidth(2);
  		b10->Draw();
 		TLine *b220 = new TLine(1.2345411, 0 ,1.2345411, 850);
 		b220->SetLineColor(kRed);
  		b220->SetLineWidth(2);
 		b220->Draw("");
  		TLine *b30 = new TLine(1.2313258, 0 ,1.2313258, 850);
  		b30->SetLineColor(kRed);
  		b30->Draw("same");
  		TLine *b240 = new TLine(1.229339, 0 ,1.229339, 850);
  		b240->SetLineColor(kRed);
  		b240->SetLineWidth(2);
 		b240->Draw("same");
  		TLine *b50 = new TLine(1.228136, 0 ,1.228136, 850);
  		b50->SetLineColor(kRed);
  		b50->Draw("same");
  		TLine *b60 = new TLine(1.22627, 0 ,1.22627, 850);
  		b60->SetLineColor(kRed);
  		b60->Draw("same");
  		//TLine *b70 = new TLine(1.224897, 0 ,1.224897, 850);
  		//b70->SetLineColor(kRed);
  		//b70->Draw("same");
  		//TLine *b80 = new TLine(1.22354, 0 ,1.22354, 850);
  		//b80->SetLineColor(kRed);
  		//b80->Draw("same");
  		//TLine *b90 = new TLine(1.22175, 0 ,1.22175, 850);
  		//b90->SetLineColor(kRed);
  		//b90->Draw("same");


 		c10->cd(2);
 		h20->Draw();
 		h20->GetXaxis()->SetTitle("%");
 		h20->SetTitle("dP");	
		}
return 0;
}
