#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <string.h>

#include "TTree.h"
#include "TFile.h"
#include "TString.h"

#include "TSystem.h"
#include "TH1.h"
#include "TH2.h"
#include "TH3.h"
#include "TCanvas.h"
#include "TStyle.h"
#include "TChain.h"
#include "TEllipse.h"
#include "TLine.h"
#include "TMarker.h"
#include "TVector3.h"
#include "TRotation.h"
#include "TMath.h"
#include "TROOT.h"
#include "TF1.h"
#include "TGraph.h"
#include "TGraphErrors.h"
#include "TLatex.h" 
#include "TPolyLine.h" 


#define DEUTERON_MASS 1.875614
#define PROTON_MASS 0.93827
#define RAD2DEG 57.295779
#define DEG2RAD 0.017453293

using namespace std;

void HallA_style() {

  gROOT->SetStyle("Plain");
  gStyle->SetPaperSize(TStyle::kUSLetter);
  gStyle->SetPaperSize(18,22);
  gStyle->SetOptFit(0);
  gStyle->SetPalette(1);
  gStyle->SetNdivisions(508);
  
  gStyle->SetCanvasColor(10);
  gStyle->SetPadTopMargin(.05);
  gStyle->SetPadLeftMargin(.15);
  gStyle->SetPadRightMargin(.1);
  gStyle->SetPadBottomMargin(.10);
  gStyle->SetTitleYOffset(1.7);
  gStyle->SetTitleXOffset(1.2);
  gStyle->SetLabelFont(42,"X");
  gStyle->SetLabelFont(42,"Y");

  gStyle->SetTitleX(0.2);
  gStyle->SetTitleW(0.7);
  gStyle->SetTitleFillColor(18);

  // prepare gStyle to be useful
  //   1 = solid
  //   2 = long dash (30 10)
  //   3 = dotted (4 8)
  //   4 = dash-dot (15 12 4 12)
  //   5 = short dash ( 15 15 )
  //   6 = dash-dot-dot 
  gStyle->SetLineStyleString(1,"[]");
  gStyle->SetLineStyleString(2,"[30 10]");
  gStyle->SetLineStyleString(3,"[4 8]");
  gStyle->SetLineStyleString(4,"[15 12 4 12]");
  gStyle->SetLineStyleString(5,"[15 15]");
  gStyle->SetLineStyleString(6,"[15 12 4 12 4 12]");
  gStyle->SetLabelSize(0.04,"X");
  gStyle->SetLabelSize(0.04,"Y");
  gStyle->SetNdivisions(508,"Y");
  gStyle->SetOptDate(0);
  gStyle->SetDateY(.98);
  gStyle->SetStripDecimals(kFALSE);


  gStyle->SetOptStat(0);

}

using namespace std;

int p0v53(){

  HallA_style();

  TString produceroot, Y="Y", N="N";


  cout<<"################### ROOT File to Histogram ROOT File #######################"<<endl;
  while(produceroot.CompareTo(Y)!=0 && produceroot.CompareTo(N)!=0){


	cout<<"A SPRODUCIRAM HISTOGRAME V ROOT: (Y/N)"<<endl;
        cin>>produceroot;

	if(produceroot.CompareTo(N)==0) break;
	if(produceroot.CompareTo(Y)==0){


		Double_t L_gold_ph;
		Double_t L_gold_dp;
		Double_t  grafPh[2], grafdP[2], grafdPPh[2];
		Int_t runnumber;
		cout<<"Vpisi Run Number:"<<endl;
 		cin>>runnumber;
  		cout<<"Run Number je: "<<runnumber<<endl;

/*
  		cout<<"Vpisi meje za Ph histogram:"<<endl<<"Prva meja:"<<endl;
  		cin>>grafPh[0];
  		cout<<"Prva meja je: "<<grafPh[0]<<endl<<"Druga meja;"<<endl;
  		cin>>grafPh[1];
  		cout<<"Druga meja meja je: "<<grafPh[1]<<endl;

  		cout<<"Vpisi meje za dP histogram:"<<endl<<"Prva meja:"<<endl;
  		cin>>grafdP[0];
  		cout<<"Prva meja je: "<<grafdP[0]<<endl<<"Druga meja;"<<endl;
  		cin>>grafdP[1];
  		cout<<"Druga meja meja je: "<<grafdP[1]<<endl;

  		cout<<"Vpisi meje za dP:Ph histogram:"<<endl<<"Prva meja:"<<endl;
  		cin>>grafdPPh[0];
  		cout<<"Prva meja je: "<<grafdPPh[0]<<endl<<"Druga meja;"<<endl;
  		cin>>grafdPPh[1];
  		cout<<"Druga meja meja je: "<<grafdPPh[1]<<endl; 
*/

	//#######################    BRANJE IZ DATOTEKE data ##############################
			TString filenamedata=Form("PROJEKT/beame0/DATAHIST/%ddata.txt", runnumber);
			ifstream data;
        		data.open (filenamedata.Data());

			int counter=0;
			if (data.is_open())
  			{
    			  	while ( ! data.eof() ){
    		  			double berime;
	 	   			data>>berime;
         	   			cout<<berime<<endl;
         	   			if (counter<2){
         	     				grafPh[counter]=berime;
          	  			}
         	   			if (1<counter<4){
         	     				grafdP[counter-2]=berime;
          	  			}
          	  			else{
           	   				grafdPPh[counter-4]=berime;
           	 			}
          	  			counter++;
					}
        			data.close();
  			}
  			else cout << "Unable to open file/n";   


  		TChain *t1 =new TChain("T");

  		TString filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber, runnumber);
  		t1->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber, runnumber);
  		t1->Add(filename.Data());

  		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+1, runnumber+1);
  		t1->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+1, runnumber+1);
  		t1->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+2, runnumber+2);
  		t1->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+2, runnumber+2);
  		t1->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+3, runnumber+3);
  		t1->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+3, runnumber+3);
  		t1->Add(filename.Data());


  		assert(t1);


  		TChain *t2 =new TChain("T");

  		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber, runnumber);
  		t2->Add(filename.Data());
 		filename = Form("./PROJEKTdata/%d/projekt%d_1.root", runnumber, runnumber);
  		t2->Add(filename.Data());

		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+1, runnumber+1);
  		t2->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+1, runnumber+1);
  		t2->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+2, runnumber+2);
  		t2->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+2, runnumber+2);
  		t2->Add(filename.Data());
  		
		filename = Form("./PROJEKTdata/%d/projekt%d.root", runnumber+3, runnumber+3);
  		t2->Add(filename.Data()); 
  		filename = Form("./PROJEKTdata/%d/projekt%d_1.root",runnumber+3, runnumber+3);
  		t2->Add(filename.Data());

  	
  		assert(t2);
  
	//############################ VARIABLES ############################

  		t1->SetBranchAddress( "L.gold.ph", &L_gold_ph);
  		t2->SetBranchAddress( "L.gold.dp", &L_gold_dp);
	//##############0.26############## Histograms ############################


  		TH1F *h1 = new TH1F("h1","h1",300,grafPh[0]+17*DEG2RAD,grafPh[1]+17*DEG2RAD);
  		TH1F *h2 = new TH1F("h2","h2",300,grafdP[0],grafdP[1]);
		TH1F *h3 = new TH1F("h3","h3",1000,grafdPPh[0], grafdPPh[1]);
 

//#######################    BRANJE IZ DATOTEKE datap0 ##############################
			TString filenamedata3=Form("PROJEKT/beame0/DATAP0/%d.txt", runnumber);
			ifstream data3;
        		data3.open (filenamedata3.Data());
			Double_t p0;
			int counter3=0;
			if (data3.is_open())
  			{
    			  	while ( ! data3.eof() ){
    		  			double berime;
	 	   			data3>>berime;
         	   			cout<<berime<<endl;
         	   			if (counter3<1){
         	     				p0=berime;
          	  			}
         	   			           	 			
          	  			counter3++;
					}
        			data3.close();
  			}
  			else cout << "Unable to open file/n";  

	//############################ Analysis VSE ############################

  		int num = t1->GetEntries();
  		num = 30000;
  		cout<<"Number of entries : "<<num<<endl;

 		for (int i = 0; i<num; i++)
  		{
   		t1->GetEntry(i);
		t2->GetEntry(i);
    		if ((i%1000==0) && i>0) cout<<i<<endl; 

	//################ Primary Cuts ################################


                                                  
	//##############################################################  

   		h1->Fill(L_gold_ph+17*DEG2RAD);  
		h2->Fill(L_gold_dp);
		//h3->Fill( 1.23956*(1+L_gold_dp)/(1- 1.23956*(1+L_gold_dp)*(1-cos(L_gold_ph+17*DEG2RAD))/11.177808));
		h3->Fill( p0*(1+L_gold_dp)/(1- p0*(1+L_gold_dp)*(1-cos(L_gold_ph+17*DEG2RAD))/11.177808));
  		}

  		delete t1; t1=NULL;
		delete t2; t2=NULL;
		

	//########################### OUTPUTFILE###############


		TString filename3=Form("~/PROJEKT/beame0/HIST/%d555.root",runnumber);
		TFile *OutputRoot = new TFile( filename3.Data(), "RECREATE");
		h1->Write();
		h2->Write();
		h3->Write();
		delete OutputRoot; OutputRoot=NULL;
		
		produceroot=3;
		TString narisemhisto=3;
		cout<<"A narisem: (Y/N)"<<endl;
        	cin>>narisemhisto;
		if(narisemhisto.CompareTo(Y)==0) {

			TString canvasname=Form("Energije sipanih elektronov %d CELI HISTOGRAMI", runnumber);
		        TCanvas *c0 = new TCanvas(canvasname,canvasname,1000,1000);

 			c0->Divide(3,1);
 			c0->cd(1);
 			h1->Draw();
 			h1->GetXaxis()->SetTitle("p [GeV/c]");
 			h1->SetTitle("Ph");

 			c0->cd(2);
 			h2->Draw();
 			h2->GetXaxis()->SetTitle("%");
 			h2->SetTitle("dP");	
			
			c0->cd(3);	
			h3->Draw();


		}
	}
  }
/*
//################################ RISANJE CELIH HISTOGRAMOV

	cout<<"###############  RISANJE CELIH HISTOGRAMOV  #################"<<endl;

	Int_t runnumber=3;
	HallA_style();

	while(runnumber!=0){      
		cout<<"Vpisi Run Number ali konec: (runnumber/0)"<<endl;
        	cin>>runnumber;
		if(runnumber==0) break;
		TString celihistogrami=Form("~/PROJEKT/P0/HIST/%d.root", runnumber);
  		TFile *file = new TFile(celihistogrami.Data());
  		TH1F *h10=(TH1F*)file->Get("h1");
  		TH1F *h20=(TH1F*)file->Get("h2");	

	
		TString canvasname=Form("Energije sipanih elektronov %d CELI HISTOGRAMI", runnumber);
		TCanvas *c10 = new TCanvas(canvasname,canvasname,1000,500);

 		c10->Divide(2,1);
 		c10->cd(1);
 		h10->Draw();
 		h10->GetXaxis()->SetTitle("p [GeV/c]");
 		h10->SetTitle("P");
 		c10->cd(2);
 		h20->Draw();
 		h20->GetXaxis()->SetTitle("%");
 		h20->SetTitle("dP");	

			TLine *b10 = new TLine(1.23898, 0 ,1.23898, 850);
  			b10->SetLineColor(kRed);
  			b10->SetLineWidth(2);
  			b10->Draw();
 			TLine *b220 = new TLine(1.2345411, 0 ,1.2345411, 850);
 			b220->SetLineColor(kRed);
  			b220->SetLineWidth(2);
 			b220->Draw("");
  			TLine *b30 = new TLine(1.2313258, 0 ,1.2313258, 850);
  			b30->SetLineColor(kRed);
  			b30->Draw("same");
  			TLine *b240 = new TLine(1.229339, 0 ,1.229339, 850);
  			b240->SetLineColor(kRed);
  			b240->SetLineWidth(2);
 			b240->Draw("same");
  			TLine *b50 = new TLine(1.228136, 0 ,1.228136, 850);
  			b50->SetLineColor(kRed);
  			b50->Draw("same");
  			TLine *b60 = new TLine(1.22627, 0 ,1.22627, 850);
  			b60->SetLineColor(kRed);
  			b60->Draw("same");
  			//TLine *b70 = new TLine(1.224897, 0 ,1.224897, 850);
  			//b70->SetLineColor(kRed);
  			//b70->Draw("same");
  			//TLine *b80 = new TLine(1.22354, 0 ,1.22354, 850);
  			//b80->SetLineColor(kRed);
  			//b80->Draw("same");
  			//TLine *b90 = new TLine(1.22175, 0 ,1.22175, 850);
  			//b90->SetLineColor(kRed);
  			//b90->Draw("same");

		}
*/
//################################     IZ ROOT HISTOGRAMOV NAPREJ       ###########################
	Int_t runnumber=3; //narisem;
	TString narisem;
 	
	cout<<"###############  OBDELAVA HISTOGRAMOV NAPREJ  #################"<<endl;
	while(runnumber!=0) {
        	cout<<"Vpisi Run Number ali konec: (runnumber/0)"<<endl;
        	cin>>runnumber;
		cout<<"Run Number je: "<<runnumber<<endl;
		if(runnumber==0) break;
		narisem=3;
		//while(narisem.CompareTo(Y)!=0 && narisem.CompareTo(N)!=0){
			//cout<<"A narisem: (Y/N)"<<endl;
        	//	cin>>narisem;
		//}
		//if(narisem.CompareTo(Y)==0){

	/*//#######################    BRANJE IZ DATOTEKE data ##############################
			TString filenamedata=Form("PROJEKT/beame0/DATA/%ddata.txt", runnumber);
			ifstream data;
        		data.open (filenamedata.Data());

			int counter=0;
			if (data.is_open())
  			{
    			  	while ( ! data.eof() ){
    		  			double berime;
	 	   			data>>berime;
         	   			cout<<berime<<endl;
         	   			if (counter<4){
         	     				fitprvigraf[counter]=berime;
          	  			}
          	  			else{
           	   				fitdrugigraf[counter-4]=berime;
           	 			}
          	  			counter++;
					}
        			data.close();
  			}
  			else cout << "Unable to open file/n";   */

	//######################   BRANJE HISTOGRAMOV IZ DATOTEKE root   ############################
		  			HallA_style();
  			TString filename=Form("~/PROJEKT/beame0/HIST/%d.root", runnumber);
  			TFile *file = new TFile(filename.Data());
  			TH1F *h1=(TH1F*)file->Get("h1");
  			TH1F *h2=(TH1F*)file->Get("h2");	
			TH2F *h3=(TH2F*)file->Get("h3");	


	//###########################   RISANJE Canvas C0   ##################################
			TString canvasname=Form("Energije sipanih elektronov %d", runnumber);
		        TCanvas *c0 = new TCanvas(canvasname,canvasname,1000,1000);
			TString imeh=Form("Ph %d", runnumber);
 			c0->Divide(3,2);
 			c0->cd(1);
 			h1->Draw();
 			h1->GetXaxis()->SetTitle("ph [GeV/c]");
 			h1->SetTitle(imeh);

			

	/*###################### RISANJE    fitting prvi graf        ##################
		
  			TF1 *g1    = new TF1("g1","gaus", fitprvigraf[0], fitprvigraf[1]);
  			h1->Fit(g1,"R");
  
  			TF1 *g2    = new TF1("g2","gaus",fitprvigraf[2],fitprvigraf[3]);
  			h1->Fit(g2,"R+");
			
 	*/		
	//#####################  RISANJE      dp                 #########################
	
  			c0->cd(2);
			TString imeh2=Form("dP %d", runnumber);
 			h2->Draw();
 			h2->GetXaxis()->SetTitle("dp [GeV/c]");
 			h2->SetTitle(imeh2);
			
        //######################RISANJE ph:dp
  			c0->cd(3);
			TString imeh3=Form("dP:ph %d", runnumber);
 			h3->Draw();

	//#######################    BRANJE IZ DATOTEKE datafit ##############################
			TString filenamedata=Form("PROJEKT/beame0/DATAFIT/%d.txt", runnumber);
			ifstream data;
        		data.open (filenamedata.Data());
			Double_t fitgraf[6];
			int counter=0;
			if (data.is_open())
  			{
    			  	while ( ! data.eof() ){
    		  			double berime;
	 	   			data>>berime;
         	   			cout<<berime<<endl;
         	   			if (counter<2){
         	     				fitgraf[counter]=berime;
          	  			}
         	   			if (1<counter<4){
         	     				fitgraf[counter]=berime;
          	  			}
          	  			else{
           	   				fitgraf[counter]=berime;
           	 			}
          	  			counter++;
					}
        			data.close();
  			}
  			else cout << "Unable to open file/n";   
	//###################### RISANJE    fitting prvi graf        ##################
		
  			TF1 *g1    = new TF1("g1","gaus", fitgraf[0], fitgraf[1]);
  			h3->Fit(g1,"R");
  
  			TF1 *g2    = new TF1("g2","gaus",fitgraf[2],fitgraf[3]);
  			h3->Fit(g2,"R+");
			
  			TF1 *g3   = new TF1("g3","gaus",fitgraf[4],fitgraf[5]);
  			h3->Fit(g3,"R+");
			g3->SetMarkerColor(2);

			double chisq1=g1->GetChisquare();
			double ndf1=g1->GetNDF();
			double chisqdf1=chisq1/ndf1;
			cout << "Chisquare: " << chisq1 << "/" << ndf1 << " : " << chisqdf1 << endl;
			double chisq2=g2->GetChisquare();
			double ndf2=g2->GetNDF();
			double chisqdf2=chisq2/ndf2;
			cout << "Chisquare: " << chisq2 << "/" << ndf2 << " : " << chisqdf2 << endl;
			double chisq3=g3->GetChisquare();
			double ndf3=g3->GetNDF();
			double chisqdf3=chisq3/ndf3;
			cout << "Chisquare: " << chisq3 << "/" << ndf3 << " : " << chisqdf3 << endl;
			
			Double_t mean1 = g1->GetParameter(1); 
			Double_t emean1 = g1->GetParError(1); 
			Double_t mean2 = g2->GetParameter(1); 
			Double_t emean2 = g2->GetParError(1); 
			Double_t mean3 = g3->GetParameter(1); 
			Double_t emean3 = g3->GetParError(1); 
		
			c0->cd(4);
		
			TString beseda = Form("p_{1}= %.5f #pm %.5f + 0.009641 #frac{MeV}{c}= %.5f", mean1, emean1, mean1+0.009641);
			TString beseda2 = Form("p_{2}= %.5f #pm %.5f + 0.0044389 #frac{MeV}{c}= %.5f", mean2, emean2, mean2+0.0044389);
			TString beseda3 = Form("p_{3}= %.5f #pm %.5f #frac{MeV}{c}", mean3, emean3);
			


			TLatex ltext1;
			ltext1.SetTextSize(0.04);
			ltext1.DrawLatex(0.1, 0.8, beseda.Data());		
			TLatex ltext2;
			ltext2.SetTextSize(0.04);
			ltext2.DrawLatex(0.1, 0.6, beseda2.Data());
			TLatex ltext3;
			ltext3.SetTextSize(0.04);
			ltext3.DrawLatex(0.1, 0.4, beseda3.Data());
					
			c0->cd(5);

			Double_t e0[3]={ mean3, mean2, mean1};
			Double_t ere0[3]={emean3, emean2, emean1};

			double I[100];
			for(int l=0; l<100; l++){
			I[l]=l;
			}
			

			TGraphErrors *graffit= new TGraphErrors(3, I, e0, 0 ,ere0);
  			graffit->SetMarkerStyle(20);
  			graffit->SetMarkerColor(3);
			graffit->Draw("AP");
			graffit->SetTitle("povprecje");
			graffit->GetYaxis()->SetTitle("Mev/c");
   			TF1 *e0fit1 = new TF1("e0fit1","[0]",-1, 3);
   			graffit->Fit(e0fit1,"RW");
  
			double chisqfit=e0fit1->GetChisquare();
			double ndffit=e0fit1->GetNDF();
			double chisqdffit=chisqfit/ndffit;
			cout << "Chisquare: " << chisqfit << "/" << ndffit << " : " << chisqdffit << endl;

			c0->cd(6);
			TString rezultat = Form("beam e_{0}= %.5f #pm %.5f",e0fit1->GetParameter(0),  e0fit1->GetParError(0) );
	
			TLatex rtext;
			rtext.SetTextSize(0.04);
			rtext.DrawLatex(0.1, 0.8, rezultat.Data());		

	}
	cout<<"KONEC LONEC"<<endl;
	
return 0;	
}





